



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【C++ Primer 第10章】再探迭代器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【C++ Primer 第10章】再探迭代器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 13:15:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>反向迭代器</h2>
<p>&bull; 反向迭代器就是在容器中从尾元素向首元素反向移动的迭代器。对于反向迭代器，递增（以及递减）操作的含义会颠倒过来。</p>
<p>&bull; 递增一个反向迭代器（++it）会移动到前一个元素；递减一迭代器（--it）会移动到下一个元素。</p>
<p>&bull; 除了forward_list之外，其他容器都支持反向迭代器。我们可以通过调用rbegin、rcend、crbegin和crend成员函数来获得反向迭代器。这些成员函数返回指向容器尾元素和首元素之前一个位置的迭代器。与普通迭代器一样，反向迭代器也有const和非const版本。</p>
<div>
<pre class="prettyprint linenums"> #include&lt;iostream&gt;<br />
 #include&lt;vector&gt;<br />
 #include&lt;iterator&gt;<br />
 using namespace std;

 int main()<br />
 {<br />
     vector&lt;int&gt; vec = { , , , , , , , , ,  };<br />
     for (auto r_iter = vec.crbegin(); r_iter != vec.crend(); ++r_iter)<br />
         cout &lt;&lt; *r_iter &lt;&lt; " ";<br />
     cout &lt;&lt; endl;<br />
     return ;<br />
 }</pre>
</div>
<p>输出结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1303039/201805/1303039-20180529214032819-1981426803.png" /></p>
<p>虽然颠倒递增和递减运算符的含义可能令人混淆，但这样做是我们可以用算法透明地向前或向后处理容器。例如，可以通过向sort传递一对反向迭代器来将vector整理为递减序：</p>
<div>
<pre class="prettyprint linenums">sort(vec.begin(),vec.end());<br />
sort(vec.rbegin(),vec.rend());</pre>
</div>
<div>
<pre class="prettyprint linenums"> #include &lt;iostream&gt;<br />
 #include &lt;deque&gt;<br />
 #include &lt;algorithm&gt;<br />
 #include &lt;iterator&gt;<br />
 using namespace std;

 void print(int elem)<br />
 {<br />
     cout &lt;&lt; elem &lt;&lt; ' ';<br />
 }

 int main()<br />
 {<br />
     deque&lt;int&gt; coll;<br />
     for (int i = ; i &lt;= ; ++i)<br />
         coll.push_back(i);

     deque&lt;int&gt;::iterator pos1;<br />
     pos1 = find(coll.begin(), coll.end(), );

     deque&lt;int&gt;::iterator pos2;<br />
     pos2 = find(coll.begin(), coll.end(), );<br />
     for_each(pos1, pos2, print);<br />
     cout &lt;&lt; endl;

     deque&lt;int&gt;::reverse_iterator rpos1(pos1);<br />
     deque&lt;int&gt;::reverse_iterator rpos2(pos2);<br />
     for_each(rpos2, rpos1, print);<br />
     cout &lt;&lt; endl;<br />
     return ;<br />
 }</pre>
</div>
<p>输出结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1303039/201805/1303039-20180529220522991-1501930193.png" /></p>
<p>【分析】</p>
<p>代码首先在一个deque中插入1到9，然后查找元素值为2和7的位置，分别赋值给迭代器pos1和pos2，然后输出，由于STL中的操作总是左开右闭的区间，即[2,7)，所以输出2 3 4 5 6，7不会输出。</p>
<p>接下来将迭代器转换成逆向迭代器，再次输出，对于反向迭代器，由于是反向，所以按逻辑来说它是左开右闭的（这里我尝试了rpos2为iterator.end(),rpos1为iterator.begin(),此时输出全部），即(7,2]（事实上还是左闭右开，只不过此时的左和iterator顺序一样）。所以输出6 5 4 3 2，下面的图片解释的很清楚。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1000464/201611/1000464-20161124151737550-79594255.jpg" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pjgyz9.html">使用NuGet发布自己的类库包（Library Package）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvjkgxq.html">IOS中CoreData浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwew43q.html">JAVA多线程基础知识（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o0gl18.html">Maven&plus;SSM搭建总结（非教程）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2plgv8.html">Effective Java 68 Prefer executors and tasks to threads</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p0zokq.html">取消chrome浏览器下input和textarea的默认样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw6me39.html">获取表信息（MSSQL）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvkxy1q.html">PAT 1003</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdevxnv9.html">HTML及简单标签介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1nkyd9.html">LXC是如何与CGROUP，namespace扯上关系的？再加上DOCKER&period;IO。完美！！！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvjvx9.html">Jquery-鼠标事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjzmk38.html">纯CSS实现箭头、气泡让提示功能具有三角形图标（简单实例）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yry3w8.html">Lombok介绍、使用方法和总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zvn6g9.html">c语言博客作业-指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506grm8.html">Openstack基础环境交换机常用配置&lpar;CISCO 3750G为例&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20w5o9.html">&vert;ERROR&vert;ERROR&colon;  missing data for column &amp;quot&semi;createtime&amp;quot&semi;  &lpar;seg3 slice1 192&period;168&period;66&period;23&colon;40001 pid&equals;33370&rpar;之mysql换行符或者空格引起的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r51dl4q.html">springboot整合视图层之jsp</a>
		</li>
						<li><a href="https://www.batexi.com/a/960lm149.html">react-router解决锚点跳转问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/960zy0n9.html">（转）css3实现load效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/960e5739.html">delphi reintroduce作用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnvk2ox8.html">CentOS下安装zookeeper并设置开机自启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw3olx9.html">【&starf;&starf;&starf;&starf;&starf;】提高PHP代码质量的36个技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjlvg79.html">IntelliJ IDEA AndroidStudio SVN无法使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw3z679.html">六道JavaScript测验题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2vy16q.html">第4月第10天 iOS项目 mvc</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwy2o78.html">L - The Shortest Path Gym - 101498L （dfs式spfa判断负环）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j2623q.html">2018-2019-2 网络对抗技术 20165227 Exp3 免杀原理与实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25n6zlq.html">Java 注解 （Annotation）你可以这样学</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ow3xe8.html">log4j日志日记记录使用教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ow3yk8.html">SpringBoot集成监控管理</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
